<template>
    <div class="relative mt-4">
        <label v-if="!disabled" class="mt-4">File attachments</label>
        <VFileInput v-if="!disabled" @onUpload="handleUpload" accept="image/*" class="mt-3 mb-3" />
        <div class="space-y-2" v-if="files.length > 0">
            <label>Files</label>
            <div class="bg-gray-50 border rounded-lg">
                <table class="space-y-5 w-full ">
                    <tr v-for="(file, i) in files" :key="i">
                        <td class="px-5 py-3">
                            <div class="flex items-center">
                                <div class="min-w-[100px]">
                                    <a @click="onViewImage(file?.fileUuid)" class="text-blue-400" href="#">{{
                                            file?.fileName
                                    }}</a>
                                    <div class="text-sm text-gray-700">{{ (file?.fileSize / 1000000).toFixed(2) }} MB
                                    </div>
                                </div>
                            </div>
                        </td>
                        <td class="px-5 text-right">
                            <button v-if="!disabled" type="button" @click="onDeleteFile(file?.fileUuid)"
                                class="text-white bg-red-700 hover:bg-red-800 focus:outline-none focus:ring-4 focus:ring-red-300 font-medium rounded-full text-sm px-3 py-2 text-center ">
                                <fa-icon icon="fa-solid fa-trash-can" />
                            </button>
                        </td>
                    </tr>

                </table>
            </div>

        </div>
    </div>
    <VImageView v-model="show" :src="fileBase64" />
</template>

<script>
import VFileInput from "@/components/VFileInput";
import { mapActions, mapState } from 'vuex';
import VImageView from '@/components/VImageViewer';

export default {
    name: "VAttachment",
    components: {
        VFileInput,
        VImageView
    },
    props: {
        data: {
            type: Object,
            default: () => ({})
        },
        disabled: {
            type: Boolean,
            default: false
        }
    },
    data: () => ({
        show: false
    }),
    created() {
        this.fetchFiles({
            ref: this.data?.namespace || "default",
            id: this.data?.id || -1
        });
    },
    computed: {
        ...mapState("Attachment", ["files", "fileBase64"])
    },
    methods: {
        ...mapActions("Attachment", ["fetchFiles", "uploadFile", "deleteFile", "fetchFileView"]),
        handleUpload(file) {
            this.uploadFile({
                file,
                ref: this.data?.namespace || "default",
                id: this.data?.id || -1
            });
        },
        async onDeleteFile(uid) {
            await this.deleteFile(uid);
            await this.fetchFiles({
                ref: this.data?.namespace || "default",
                id: this.data?.id || -1
            });
        },
        async onViewImage(uid) {
            await this.fetchFileView(uid);
            this.show = true;
        }
    }
}
</script>
